/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB Code Configurator - v2.0.1
        Device            :  PIC16F1825
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.31
        MPLAB             :  MPLAB X 2.10
*/

/*
Copyright (c) 2013 - 2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set LIGHT_EMITTER aliases
#define LIGHT_EMITTER_TRIS               TRISA5
#define LIGHT_EMITTER_LAT                LATA5
#define LIGHT_EMITTER_PORT               RA5
#define LIGHT_EMITTER_WPU                WPUA5
#define LIGHT_EMITTER_SetHigh()    do { LATA5 = 1; } while(0)
#define LIGHT_EMITTER_SetLow()   do { LATA5 = 0; } while(0)
#define LIGHT_EMITTER_Toggle()   do { LATA5 = ~LATA5; } while(0)
#define LIGHT_EMITTER_GetValue()         RA5
#define LIGHT_EMITTER_SetDigitalInput()    do { TRISA5 = 1; } while(0)
#define LIGHT_EMITTER_SetDigitalOutput()   do { TRISA5 = 0; } while(0)

#define LIGHT_EMITTER_SetPullup()    do { WPUA5 = 1; } while(0)
#define LIGHT_EMITTER_ResetPullup()   do { WPUA5 = 0; } while(0)
// get/set LIGHT_SENSOR aliases
#define LIGHT_SENSOR_TRIS               TRISA4
#define LIGHT_SENSOR_LAT                LATA4
#define LIGHT_SENSOR_PORT               RA4
#define LIGHT_SENSOR_WPU                WPUA4
#define LIGHT_SENSOR_ANS                ANSA4
#define LIGHT_SENSOR_SetHigh()    do { LATA4 = 1; } while(0)
#define LIGHT_SENSOR_SetLow()   do { LATA4 = 0; } while(0)
#define LIGHT_SENSOR_Toggle()   do { LATA4 = ~LATA4; } while(0)
#define LIGHT_SENSOR_GetValue()         RA4
#define LIGHT_SENSOR_SetDigitalInput()    do { TRISA4 = 1; } while(0)
#define LIGHT_SENSOR_SetDigitalOutput()   do { TRISA4 = 0; } while(0)

#define LIGHT_SENSOR_SetPullup()    do { WPUA4 = 1; } while(0)
#define LIGHT_SENSOR_ResetPullup()   do { WPUA4 = 0; } while(0)
#define LIGHT_SENSOR_SetAnalogMode()   do { ANSA4 = 1; } while(0)
#define LIGHT_SENSOR_SetDigitalMode()   do { ANSA4 = 0; } while(0)
// get/set RA3 procedures
#define RA3_GetValue()         RA3
#define RA3_SetDigitalInput()    do { TRISA3 = 1; } while(0)
#define RA3_SetDigitalOutput()   do { TRISA3 = 0; } while(0)
#define RA3_SetPullup()    do { WPUA3 = 1; } while(0)
#define RA3_ResetPullup()   do { WPUA3 = 0; } while(0)
// get/set IO_RA2 aliases
#define IO_RA2_TRIS               TRISA2
#define IO_RA2_LAT                LATA2
#define IO_RA2_PORT               RA2
#define IO_RA2_WPU                WPUA2
#define IO_RA2_ANS                ANSA2
#define IO_RA2_SetHigh()    do { LATA2 = 1; } while(0)
#define IO_RA2_SetLow()   do { LATA2 = 0; } while(0)
#define IO_RA2_Toggle()   do { LATA2 = ~LATA2; } while(0)
#define IO_RA2_GetValue()         RA2
#define IO_RA2_SetDigitalInput()    do { TRISA2 = 1; } while(0)
#define IO_RA2_SetDigitalOutput()   do { TRISA2 = 0; } while(0)

#define IO_RA2_SetPullup()    do { WPUA2 = 1; } while(0)
#define IO_RA2_ResetPullup()   do { WPUA2 = 0; } while(0)
#define IO_RA2_SetAnalogMode()   do { ANSA2 = 1; } while(0)
#define IO_RA2_SetDigitalMode()   do { ANSA2 = 0; } while(0)
// get/set IO_RA1 aliases
#define IO_RA1_TRIS               TRISA1
#define IO_RA1_LAT                LATA1
#define IO_RA1_PORT               RA1
#define IO_RA1_WPU                WPUA1
#define IO_RA1_ANS                ANSA1
#define IO_RA1_SetHigh()    do { LATA1 = 1; } while(0)
#define IO_RA1_SetLow()   do { LATA1 = 0; } while(0)
#define IO_RA1_Toggle()   do { LATA1 = ~LATA1; } while(0)
#define IO_RA1_GetValue()         RA1
#define IO_RA1_SetDigitalInput()    do { TRISA1 = 1; } while(0)
#define IO_RA1_SetDigitalOutput()   do { TRISA1 = 0; } while(0)

#define IO_RA1_SetPullup()    do { WPUA1 = 1; } while(0)
#define IO_RA1_ResetPullup()   do { WPUA1 = 0; } while(0)
#define IO_RA1_SetAnalogMode()   do { ANSA1 = 1; } while(0)
#define IO_RA1_SetDigitalMode()   do { ANSA1 = 0; } while(0)
// get/set IO_RA0 aliases
#define IO_RA0_TRIS               TRISA0
#define IO_RA0_LAT                LATA0
#define IO_RA0_PORT               RA0
#define IO_RA0_WPU                WPUA0
#define IO_RA0_ANS                ANSA0
#define IO_RA0_SetHigh()    do { LATA0 = 1; } while(0)
#define IO_RA0_SetLow()   do { LATA0 = 0; } while(0)
#define IO_RA0_Toggle()   do { LATA0 = ~LATA0; } while(0)
#define IO_RA0_GetValue()         RA0
#define IO_RA0_SetDigitalInput()    do { TRISA0 = 1; } while(0)
#define IO_RA0_SetDigitalOutput()   do { TRISA0 = 0; } while(0)

#define IO_RA0_SetPullup()    do { WPUA0 = 1; } while(0)
#define IO_RA0_ResetPullup()   do { WPUA0 = 0; } while(0)
#define IO_RA0_SetAnalogMode()   do { ANSA0 = 1; } while(0)
#define IO_RA0_SetDigitalMode()   do { ANSA0 = 0; } while(0)
// get/set RX aliases
#define RX_TRIS               TRISC5
#define RX_LAT                LATC5
#define RX_PORT               RC5
#define RX_WPU                WPUC5
#define RX_SetHigh()    do { LATC5 = 1; } while(0)
#define RX_SetLow()   do { LATC5 = 0; } while(0)
#define RX_Toggle()   do { LATC5 = ~LATC5; } while(0)
#define RX_GetValue()         RC5
#define RX_SetDigitalInput()    do { TRISC5 = 1; } while(0)
#define RX_SetDigitalOutput()   do { TRISC5 = 0; } while(0)

#define RX_SetPullup()    do { WPUC5 = 1; } while(0)
#define RX_ResetPullup()   do { WPUC5 = 0; } while(0)
// get/set TX aliases
#define TX_TRIS               TRISC4
#define TX_LAT                LATC4
#define TX_PORT               RC4
#define TX_WPU                WPUC4
#define TX_SetHigh()    do { LATC4 = 1; } while(0)
#define TX_SetLow()   do { LATC4 = 0; } while(0)
#define TX_Toggle()   do { LATC4 = ~LATC4; } while(0)
#define TX_GetValue()         RC4
#define TX_SetDigitalInput()    do { TRISC4 = 1; } while(0)
#define TX_SetDigitalOutput()   do { TRISC4 = 0; } while(0)

#define TX_SetPullup()    do { WPUC4 = 1; } while(0)
#define TX_ResetPullup()   do { WPUC4 = 0; } while(0)
// get/set IO_RC3 aliases
#define IO_RC3_TRIS               TRISC3
#define IO_RC3_LAT                LATC3
#define IO_RC3_PORT               RC3
#define IO_RC3_WPU                WPUC3
#define IO_RC3_ANS                ANSC3
#define IO_RC3_SetHigh()    do { LATC3 = 1; } while(0)
#define IO_RC3_SetLow()   do { LATC3 = 0; } while(0)
#define IO_RC3_Toggle()   do { LATC3 = ~LATC3; } while(0)
#define IO_RC3_GetValue()         RC3
#define IO_RC3_SetDigitalInput()    do { TRISC3 = 1; } while(0)
#define IO_RC3_SetDigitalOutput()   do { TRISC3 = 0; } while(0)

#define IO_RC3_SetPullup()    do { WPUC3 = 1; } while(0)
#define IO_RC3_ResetPullup()   do { WPUC3 = 0; } while(0)
#define IO_RC3_SetAnalogMode()   do { ANSC3 = 1; } while(0)
#define IO_RC3_SetDigitalMode()   do { ANSC3 = 0; } while(0)
// get/set IO_RC2 aliases
#define IO_RC2_TRIS               TRISC2
#define IO_RC2_LAT                LATC2
#define IO_RC2_PORT               RC2
#define IO_RC2_WPU                WPUC2
#define IO_RC2_ANS                ANSC2
#define IO_RC2_SetHigh()    do { LATC2 = 1; } while(0)
#define IO_RC2_SetLow()   do { LATC2 = 0; } while(0)
#define IO_RC2_Toggle()   do { LATC2 = ~LATC2; } while(0)
#define IO_RC2_GetValue()         RC2
#define IO_RC2_SetDigitalInput()    do { TRISC2 = 1; } while(0)
#define IO_RC2_SetDigitalOutput()   do { TRISC2 = 0; } while(0)

#define IO_RC2_SetPullup()    do { WPUC2 = 1; } while(0)
#define IO_RC2_ResetPullup()   do { WPUC2 = 0; } while(0)
#define IO_RC2_SetAnalogMode()   do { ANSC2 = 1; } while(0)
#define IO_RC2_SetDigitalMode()   do { ANSC2 = 0; } while(0)
// get/set SUSTAIN_POWER aliases
#define SUSTAIN_POWER_TRIS               TRISC1
#define SUSTAIN_POWER_LAT                LATC1
#define SUSTAIN_POWER_PORT               RC1
#define SUSTAIN_POWER_WPU                WPUC1
#define SUSTAIN_POWER_ANS                ANSC1
#define SUSTAIN_POWER_SetHigh()    do { LATC1 = 1; } while(0)
#define SUSTAIN_POWER_SetLow()   do { LATC1 = 0; } while(0)
#define SUSTAIN_POWER_Toggle()   do { LATC1 = ~LATC1; } while(0)
#define SUSTAIN_POWER_GetValue()         RC1
#define SUSTAIN_POWER_SetDigitalInput()    do { TRISC1 = 1; } while(0)
#define SUSTAIN_POWER_SetDigitalOutput()   do { TRISC1 = 0; } while(0)

#define SUSTAIN_POWER_SetPullup()    do { WPUC1 = 1; } while(0)
#define SUSTAIN_POWER_ResetPullup()   do { WPUC1 = 0; } while(0)
#define SUSTAIN_POWER_SetAnalogMode()   do { ANSC1 = 1; } while(0)
#define SUSTAIN_POWER_SetDigitalMode()   do { ANSC1 = 0; } while(0)
// get/set FLAG_UP aliases
#define FLAG_UP_TRIS               TRISC0
#define FLAG_UP_LAT                LATC0
#define FLAG_UP_PORT               RC0
#define FLAG_UP_WPU                WPUC0
#define FLAG_UP_ANS                ANSC0
#define FLAG_UP_SetHigh()    do { LATC0 = 1; } while(0)
#define FLAG_UP_SetLow()   do { LATC0 = 0; } while(0)
#define FLAG_UP_Toggle()   do { LATC0 = ~LATC0; } while(0)
#define FLAG_UP_GetValue()         RC0
#define FLAG_UP_SetDigitalInput()    do { TRISC0 = 1; } while(0)
#define FLAG_UP_SetDigitalOutput()   do { TRISC0 = 0; } while(0)

#define FLAG_UP_SetPullup()    do { WPUC0 = 1; } while(0)
#define FLAG_UP_ResetPullup()   do { WPUC0 = 0; } while(0)
#define FLAG_UP_SetAnalogMode()   do { ANSC0 = 1; } while(0)
#define FLAG_UP_SetDigitalMode()   do { ANSC0 = 0; } while(0)

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
*/